<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleOptimizeMass.m</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleOptimizeMass_8m-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleOptimizeMass.m</div>  </div>
</div><!--header-->
<div class="contents">
<p>A simple parameter optimization example.</p>
<div class="fragment"><div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% <a class="code" href="namespaceOpenSim.html">OpenSim</a> Moco: exampleOptimizeMass.m                                        %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% Copyright (c) 2019 Stanford University and the Authors                     %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Author(s): Noah Gordon                                                     %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    %</div>
<div class="line">% not use <span class="keyword">this</span> file except in compliance with the License. You may obtain a  %</div>
<div class="line">% copy of the License at http:<span class="comment">//www.apache.org/licenses/LICENSE-2.0          %</span></div>
<div class="line">%                                                                            %</div>
<div class="line">% Unless required by applicable law or agreed to in writing, software        %</div>
<div class="line">% distributed under the License is distributed on an <span class="stringliteral">&quot;AS IS&quot;</span> BASIS,          %</div>
<div class="line">% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   %</div>
<div class="line">% See the License <span class="keywordflow">for</span> the specific language governing permissions and        %</div>
<div class="line">% limitations under the License.                                             %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line"> </div>
<div class="line">% Optimize the mass of a simple harmonic oscillator such that it follows the</div>
<div class="line">% correct trajectory specified by the state bounds </div>
<div class="line">% and the MocoMarkerFinalGoal.</div>
<div class="line"> </div>
<div class="line">stiffness = 100.0;</div>
<div class="line">mass = 5.0;</div>
<div class="line">final_time = pi * sqrt(mass / stiffness);</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line"><span class="keyword">import</span> org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">model = Model();</div>
<div class="line">model.setName(<span class="stringliteral">&#39;oscillator&#39;</span>);</div>
<div class="line">model.set_gravity(Vec3(0, 0, 0));</div>
<div class="line">body = Body(<span class="stringliteral">&#39;body&#39;</span>, 0.5*mass, Vec3(0), Inertia(0));</div>
<div class="line">model.addComponent(body);</div>
<div class="line">marker = Marker(<span class="stringliteral">&#39;marker&#39;</span>, body, Vec3(0, 0, 0));</div>
<div class="line">model.addMarker(marker);</div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line">% Allows translation along x.</div>
<div class="line">joint = SliderJoint(<span class="stringliteral">&#39;slider&#39;</span>, model.getGround(), body);</div>
<div class="line">coord = joint.updCoordinate();</div>
<div class="line">coord.setName(<span class="stringliteral">&#39;position&#39;</span>);</div>
<div class="line">model.addComponent(joint);</div>
<div class="line"> </div>
<div class="line">spring = SpringGeneralizedForce();</div>
<div class="line">spring.set_coordinate(<span class="stringliteral">&#39;position&#39;</span>);</div>
<div class="line">spring.setRestLength(0.0);</div>
<div class="line">spring.setStiffness(stiffness);</div>
<div class="line">spring.setViscosity(0.0);</div>
<div class="line">model.addComponent(spring);</div>
<div class="line"> </div>
<div class="line">% Create MocoStudy.</div>
<div class="line">% ================</div>
<div class="line">study = MocoStudy();</div>
<div class="line">study.setName(<span class="stringliteral">&#39;oscillator_spring_stiffness&#39;</span>);</div>
<div class="line"> </div>
<div class="line">% Define the optimal control problem.</div>
<div class="line">% ===================================</div>
<div class="line">problem = study.updProblem();</div>
<div class="line"> </div>
<div class="line">% Model (dynamics).</div>
<div class="line">% -----------------</div>
<div class="line">problem.setModel(model);</div>
<div class="line"> </div>
<div class="line">% Bounds.</div>
<div class="line">% -------</div>
<div class="line">% Initial time must be 0, final time is final_time.</div>
<div class="line">problem.setTimeBounds(0, final_time);</div>
<div class="line"> </div>
<div class="line">% <a class="code" href="namespaceOpenSim.html#a4286a47452ef915e89270cee497faaeca52f5e0bc3859bc5f5e25130b6c7e8881">Position</a> must be within [-5, 5] throughout the motion.</div>
<div class="line">% Initial position must be -0.5, final position must be in [0.25, 0.75].</div>
<div class="line">problem.setStateInfo(&#39;/slider/position/value&#39;, [-5.0, 5.0], -0.5, [0.25, 0.75]);</div>
<div class="line"> </div>
<div class="line">% Speed must be within [-20, 20] throughout the motion.</div>
<div class="line">% Initial and <span class="keyword">final</span> speed must be 0. Use compact syntax.</div>
<div class="line">problem.setStateInfo(<span class="stringliteral">&#39;/slider/position/speed&#39;</span>, [-20, 20], [0], [0]);</div>
<div class="line"> </div>
<div class="line">% Add Parameter. The <span class="keywordflow">default</span> initial guess <span class="keywordflow">for</span> a parameter is the midpoint of</div>
<div class="line">% its bounds, *not* the value of the <span class="keyword">property</span> in the model.</div>
<div class="line">problem.addParameter(MocoParameter(<span class="stringliteral">&#39;oscillator_mass&#39;</span>, <span class="stringliteral">&#39;body&#39;</span>, <span class="stringliteral">&#39;mass&#39;</span>,... </div>
<div class="line">    MocoBounds(0, 10)));</div>
<div class="line"> </div>
<div class="line">endpointCost = MocoMarkerFinalGoal();</div>
<div class="line">endpointCost.setPointName(<span class="stringliteral">&#39;/markerset/marker&#39;</span>);</div>
<div class="line">endpointCost.setReferenceLocation(Vec3(0.5, 0, 0));</div>
<div class="line"> </div>
<div class="line">problem.addGoal(endpointCost);</div>
<div class="line"> </div>
<div class="line">solver = study.initTropterSolver();</div>
<div class="line"> </div>
<div class="line">study.print(<span class="stringliteral">&#39;optimize_mass.omoco&#39;</span>);</div>
<div class="line"> </div>
<div class="line">sol = study.solve();</div>
<div class="line">sol.write(<span class="stringliteral">&#39;optimize_mass_solution.sto&#39;</span>);</div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
<div class="ttc" id="anamespaceOpenSim_html_a4286a47452ef915e89270cee497faaeca52f5e0bc3859bc5f5e25130b6c7e8881"><div class="ttname"><a href="namespaceOpenSim.html#a4286a47452ef915e89270cee497faaeca52f5e0bc3859bc5f5e25130b6c7e8881">OpenSim::KinematicLevel::Position</a></div><div class="ttdeci">@ Position</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:39 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
